//+------------------------------------------------------------------+
//|                                                       TestEA.mq4 |
//|                        Copyright 2019, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict

input bool in_timer_only = false; //Timer only


color bk_CHART_COLOR_BACKGROUND  = clrNONE;
bool  is_CHANGE_BACKGROUND_COLOR = false;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {  
   bk_CHART_COLOR_BACKGROUND  = ChartGetInteger(ChartID(), CHART_COLOR_BACKGROUND, 0);
   is_CHANGE_BACKGROUND_COLOR = false;  
//--- create timer
   EventSetTimer(2); //2sec
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
   EventKillTimer();
   if (is_CHANGE_BACKGROUND_COLOR) {
      ChartSetInteger(ChartID(), CHART_COLOR_BACKGROUND, bk_CHART_COLOR_BACKGROUND);
      is_CHANGE_BACKGROUND_COLOR = false;
   }   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---
   if (!in_timer_only) {
       if (is_CHANGE_BACKGROUND_COLOR) {
         ChartSetInteger(ChartID(), CHART_COLOR_BACKGROUND, bk_CHART_COLOR_BACKGROUND);
         is_CHANGE_BACKGROUND_COLOR = false;
      } else {
         ChartSetInteger(ChartID(), CHART_COLOR_BACKGROUND, clrPink);
         is_CHANGE_BACKGROUND_COLOR = true;
      }
   }
   ChartRedraw();
  }
//+------------------------------------------------------------------+
